import es, dnd, popuplib, spe, cmdlib, random, gamethread, math, weaponlib
from dnd import dnd

def load():
    spe.registerPreHook("player_spawn", pre_spawn)
    #spe.registerPreHook("player_hurt", pre_hurt)
    cmdlib.registerClientCommand('!hide', hide, 'Rogue Ability - Instantly goes into stealth')
    
    Rogue_Info = popuplib.create('Rogue Info')
    Rogue_Info.addline('Rogue Class Information:')
    Rogue_Info.addline('  Stealthed - Harder to see when not in combat')
    Rogue_Info.addline('  Level 2: Sneak Attack - deals extra damage when stealthed')
    Rogue_Info.addline('  Level 3: Dodge')
    Rogue_Info.addline('  Level 7: Combat Reflexes - Extra damage to enemies')
    Rogue_Info.addline('    not attacking you')
    Rogue_Info.addline('  Level 9: !hide - Instantly go back into stealth 1/round')
    Rogue_Info.addline('    Fails against wise opponents')
    
def unload():
    popuplib.delete('Rogue Info')
    cmdlib.unregisterClientCommand('!hide')
    spe.unregisterPreHook("player_spawn", pre_spawn)
    
def pre_spawn(ev):
    if dnd.Player(ev['userid']).getClass() == 'Rogue':
        newStealth = -145-(dnd.Player(ev['userid']).getLevel()/2*7)
        dnd.Temp(ev['userid']).add('stealth', newStealth)
        if dnd.Player(ev['userid']).getLevel() >= 9:
            dnd.Temp(ev['userid']).add('hide', 1)
    
def player_hurt(ev):
    if dnd.Player(ev['userid']).getClass() == 'Rogue':
        dnd.unstealth(ev['attacker'], 4)
        if dnd.Player(ev['userid']).getLevel() >= 3:
            if random.randint(1,10) == 1:
                if dnd.Player(ev['userid']).alive():
                    dnd.heal(ev['userid'], ev['dmg_health'])
                    dnd.dndTell(ev['userid'], 'You have dodged an attack!')
    if dnd.Player(ev['attacker']).getClass() == 'Rogue':
        if dnd.Player(ev['attacker']).getLevel() >= 2:
            if dnd.Temp(ev['attacker']).get('stealthed'):
                sneakDamage = 0
                sneakDice = dnd.Player(ev['attacker']).getLevel() / 2
                while sneakDice:
                    sneakDamage += random.randint(1,6)
                    sneakDice -= 1
                dnd.damage(ev['userid'], ev['attacker'], sneakDamage)
                dnd.dndTell(ev['attacker'], 'You did %s sneak attack damage!'%sneakDamage)
        if dnd.Player(ev['attacker']).getLevel() >= 7 and dnd.Temp(ev['userid']).get('last attacked') != int(ev['attacker']):
            dnd.damage(ev['userid'], int(ev['dmg_health']) / (6 + (2/3)), ev['attacker'])
            dnd.dndTell(ev['attacker'], 'You did an extra %s damage with Combat Reflexes'%(int(ev['dmg_health'])/(6 + (2/3))))
        dnd.unstealth(ev['attacker'], 4)
            
def hide(userid, args):
    if dnd.Player(userid).alive():
        if dnd.Player(userid).getClass() == 'Rogue' and dnd.Player(userid).getLevel() >= 9:
            if dnd.Temp(userid).get('hide'):
                dnd.Temp(userid).add('hide', -1)
                gamethread.cancelDelayed('stealth_%s'%userid)
                dnd.stealth(userid)
                
def item_pickup(ev):
    if dnd.Player(ev['userid']).getClass() == 'Rogue':
        if dnd.Temp(ev['userid']).get('stealthed'):
            handle = es.getplayerhandle(ev['userid'])
            stealth = dnd.Temp(ev['userid']).get('stealth')
            color  = 255 + (255 << 8) + (255 << 16)
            color += stealth << 24
            if color >= 2**31: color -= 2**32
            for x in weaponlib.getIndexList('#all'):
                if es.getindexprop(x, 'CBaseEntity.m_hOwnerEntity') == handle:
                    es.setindexprop(x, "CBaseEntity.m_nRenderMode", es.getindexprop(x, "CBaseEntity.m_nRenderMode") | 1)
                    es.setindexprop(x, "CBaseEntity.m_nRenderFX", es.getindexprop(x, "CBaseEntity.m_nRenderFX") | 256)
                    es.setindexprop(x, "CBaseEntity.m_clrRender", color)
    